3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
14 git_broken_path_fix
() {
25 case "$SANE_TOOL_PATH:$elem" in
26 (?
*:/bin | ?
*:/usr
/bin
)
27 path
="$path$sep$SANE_TOOL_PATH"
43 die_with_status
1 "$@"
56 if test -z "$GIT_QUIET"
62 if test -n "$OPTIONS_SPEC"; then
69 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
70 parseopt_extra
="--keep-dashdash"
73 echo "$OPTIONS_SPEC" |
74 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
78 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
80 die
"Usage: $dashless $USAGE"
83 if [ -z "$LONG_USAGE" ]
85 LONG_USAGE
="Usage: $dashless $USAGE"
87 LONG_USAGE
="Usage: $dashless $USAGE
100 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
102 GIT_REFLOG_ACTION
="$*"
103 export GIT_REFLOG_ACTION
108 if test -z "${GIT_EDITOR:+set}"
110 GIT_EDITOR
="$(git var GIT_EDITOR)" ||
return $?
113 eval "$GIT_EDITOR" '"$@"'
119 GIT_PAGER
=$
(git var GIT_PAGER
)
126 eval "$GIT_PAGER" '"$@"'
130 GREP_OPTIONS
= LC_ALL
=C
grep "$@"
134 GREP_OPTIONS
= LC_ALL
=C
egrep "$@"
137 is_bare_repository
() {
138 git rev-parse
--is-bare-repository
142 cdup
=$
(git rev-parse
--show-toplevel) &&
144 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
149 require_work_tree_exists
() {
150 if test "z$(git rev-parse --is-bare-repository)" != zfalse
152 die
"fatal: $0 cannot be used without a working tree."
156 require_work_tree
() {
157 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
158 die
"fatal: $0 cannot be used without a working tree."
161 require_clean_work_tree
() {
162 git rev-parse
--verify HEAD
>/dev
/null ||
exit 1
163 git update-index
-q --ignore-submodules --refresh
166 if ! git diff-files
--quiet --ignore-submodules
168 echo >&2 "Cannot $1: You have unstaged changes."
172 if ! git diff-index
--cached --quiet --ignore-submodules HEAD
--
176 echo >&2 "Cannot $1: Your index contains uncommitted changes."
178 echo >&2 "Additionally, your index contains uncommitted changes."
185 test -n "$2" && echo >&2 "$2"
190 get_author_ident_from_commit
() {
193 s/'\''/'\''\\'\'\''/g
195 s/^author \([^<]*\) <[^>]*> .*$/\1/
196 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
199 s/^author [^<]* <\([^>]*\)> .*$/\1/
200 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
203 s/^author [^<]* <[^>]*> \(.*\)$/@\1/
204 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
209 encoding
=$
(git config i18n.commitencoding ||
echo UTF-8
)
210 git show
-s --pretty=raw
--encoding="$encoding" "$1" -- |
211 LANG
=C LC_ALL
=C
sed -ne "$pick_author_script"
214 # Clear repo-local GIT_* environment variables. Useful when switching to
215 # another repository (e.g. when entering a submodule). See also the env
216 # list in git_connect()
217 clear_local_git_env
() {
218 unset $
(git rev-parse
--local-env-vars)
221 # Make sure we are in a valid repository of a vintage we understand,
222 # if we require to be in a git repository.
223 if test -z "$NONGIT_OK"
225 GIT_DIR
=$
(git rev-parse
--git-dir) ||
exit
226 if [ -z "$SUBDIRECTORY_OK" ]
228 test -z "$(git rev-parse --show-cdup)" ||
{
230 echo >&2 "You need to run this command from the toplevel of the working tree."
234 test -n "$GIT_DIR" && GIT_DIR
=$
(cd "$GIT_DIR" && pwd) ||
{
235 echo >&2 "Unable to determine absolute path of git directory"
238 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
241 # Fix some commands on Windows
244 # Windows has its own (incompatible) sort and find
251 is_absolute_path
() {
260 is_absolute_path
() {